-- Author	  : admin
-- Create Date : 9/27/2019 6:04:14 PM

local addonName, addonTable = ...;
local addon = LibStub('AceAddon-3.0'):NewAddon(addonTable, addonName, 'AceHook-3.0', 'AceEvent-3.0');

local levels = newArray('trivial', 'easy', 'medium', 'optimal', 'difficult');
local locale = GetLocale();
local L = setmetatable({}, {__index = function(t, name) return name end });

L["ABOUT"] = " - by Angelike"
L["CRAFTABLE"] = "Craftable"
L["CRAFTHELPER"] = "Crafthelper"
L["DIFFICULT"] = "difficult"
L["EASY"] = "easy"
L["HAS_REAGENTS"] = "Has reagents"
L["MEDIUM"] = "medium"
L["ONLY_SHOW"] = "Only show:"
L["OPTIMAL"] = "optimal"
L["TRIVIAL"] = "trivial"


if (locale == 'deDE') then
L["ABOUT"] = " - by Angelike"
L["CRAFTABLE"] = "Herstellbar"
L["CRAFTHELPER"] = "Crafthelper"
L["DIFFICULT"] = "schwierig"
L["EASY"] = "einfach"
L["HAS_REAGENTS"] = "Mit Reagenzien"
L["MEDIUM"] = "normal"
L["ONLY_SHOW"] = "Zeige nur:"
L["OPTIMAL"] = "optimal"
L["TRIVIAL"] = "gewöhnlich"

elseif (locale == 'esES') then
--[[Translation missing --]]
--[[ L["ABOUT"] = " - by Angelike"--]] 
--[[Translation missing --]]
--[[ L["CRAFTABLE"] = "Craftable"--]] 
--[[Translation missing --]]
--[[ L["CRAFTHELPER"] = "Crafthelper"--]] 
--[[Translation missing --]]
--[[ L["DIFFICULT"] = "difficult"--]] 
--[[Translation missing --]]
--[[ L["EASY"] = "easy"--]] 
--[[Translation missing --]]
--[[ L["HAS_REAGENTS"] = "Has reagents"--]] 
--[[Translation missing --]]
--[[ L["MEDIUM"] = "medium"--]] 
--[[Translation missing --]]
--[[ L["ONLY_SHOW"] = "Only show:"--]] 
--[[Translation missing --]]
--[[ L["OPTIMAL"] = "optimal"--]] 
--[[Translation missing --]]
--[[ L["TRIVIAL"] = "trivial"--]] 

elseif (locale == 'esMX') then
--[[Translation missing --]]
--[[ L["ABOUT"] = " - by Angelike"--]] 
--[[Translation missing --]]
--[[ L["CRAFTABLE"] = "Craftable"--]] 
--[[Translation missing --]]
--[[ L["CRAFTHELPER"] = "Crafthelper"--]] 
--[[Translation missing --]]
--[[ L["DIFFICULT"] = "difficult"--]] 
--[[Translation missing --]]
--[[ L["EASY"] = "easy"--]] 
--[[Translation missing --]]
--[[ L["HAS_REAGENTS"] = "Has reagents"--]] 
--[[Translation missing --]]
--[[ L["MEDIUM"] = "medium"--]] 
--[[Translation missing --]]
--[[ L["ONLY_SHOW"] = "Only show:"--]] 
--[[Translation missing --]]
--[[ L["OPTIMAL"] = "optimal"--]] 
--[[Translation missing --]]
--[[ L["TRIVIAL"] = "trivial"--]] 

elseif (locale == 'frFR') then
--[[Translation missing --]]
--[[ L["ABOUT"] = " - by Angelike"--]] 
--[[Translation missing --]]
--[[ L["CRAFTABLE"] = "Craftable"--]] 
--[[Translation missing --]]
--[[ L["CRAFTHELPER"] = "Crafthelper"--]] 
--[[Translation missing --]]
--[[ L["DIFFICULT"] = "difficult"--]] 
--[[Translation missing --]]
--[[ L["EASY"] = "easy"--]] 
--[[Translation missing --]]
--[[ L["HAS_REAGENTS"] = "Has reagents"--]] 
--[[Translation missing --]]
--[[ L["MEDIUM"] = "medium"--]] 
--[[Translation missing --]]
--[[ L["ONLY_SHOW"] = "Only show:"--]] 
--[[Translation missing --]]
--[[ L["OPTIMAL"] = "optimal"--]] 
--[[Translation missing --]]
--[[ L["TRIVIAL"] = "trivial"--]] 

elseif (locale == 'itIT') then
--[[Translation missing --]]
--[[ L["ABOUT"] = " - by Angelike"--]] 
--[[Translation missing --]]
--[[ L["CRAFTABLE"] = "Craftable"--]] 
--[[Translation missing --]]
--[[ L["CRAFTHELPER"] = "Crafthelper"--]] 
--[[Translation missing --]]
--[[ L["DIFFICULT"] = "difficult"--]] 
--[[Translation missing --]]
--[[ L["EASY"] = "easy"--]] 
--[[Translation missing --]]
--[[ L["HAS_REAGENTS"] = "Has reagents"--]] 
--[[Translation missing --]]
--[[ L["MEDIUM"] = "medium"--]] 
--[[Translation missing --]]
--[[ L["ONLY_SHOW"] = "Only show:"--]] 
--[[Translation missing --]]
--[[ L["OPTIMAL"] = "optimal"--]] 
--[[Translation missing --]]
--[[ L["TRIVIAL"] = "trivial"--]] 

elseif (locale == 'koKR') then
--[[Translation missing --]]
--[[ L["ABOUT"] = " - by Angelike"--]] 
--[[Translation missing --]]
--[[ L["CRAFTABLE"] = "Craftable"--]] 
--[[Translation missing --]]
--[[ L["CRAFTHELPER"] = "Crafthelper"--]] 
--[[Translation missing --]]
--[[ L["DIFFICULT"] = "difficult"--]] 
--[[Translation missing --]]
--[[ L["EASY"] = "easy"--]] 
--[[Translation missing --]]
--[[ L["HAS_REAGENTS"] = "Has reagents"--]] 
--[[Translation missing --]]
--[[ L["MEDIUM"] = "medium"--]] 
--[[Translation missing --]]
--[[ L["ONLY_SHOW"] = "Only show:"--]] 
--[[Translation missing --]]
--[[ L["OPTIMAL"] = "optimal"--]] 
--[[Translation missing --]]
--[[ L["TRIVIAL"] = "trivial"--]] 

elseif (locale == 'ptBR') then
--[[Translation missing --]]
--[[ L["ABOUT"] = " - by Angelike"--]] 
--[[Translation missing --]]
--[[ L["CRAFTABLE"] = "Craftable"--]] 
--[[Translation missing --]]
--[[ L["CRAFTHELPER"] = "Crafthelper"--]] 
--[[Translation missing --]]
--[[ L["DIFFICULT"] = "difficult"--]] 
--[[Translation missing --]]
--[[ L["EASY"] = "easy"--]] 
--[[Translation missing --]]
--[[ L["HAS_REAGENTS"] = "Has reagents"--]] 
--[[Translation missing --]]
--[[ L["MEDIUM"] = "medium"--]] 
--[[Translation missing --]]
--[[ L["ONLY_SHOW"] = "Only show:"--]] 
--[[Translation missing --]]
--[[ L["OPTIMAL"] = "optimal"--]] 
--[[Translation missing --]]
--[[ L["TRIVIAL"] = "trivial"--]] 

elseif (locale == 'ruRU') then
L["ABOUT"] = "- by Angelike"
L["CRAFTABLE"] = "Создаваемый"
L["CRAFTHELPER"] = "Помощник ремесел"
L["DIFFICULT"] = "сложность"
L["EASY"] = "легко"
L["HAS_REAGENTS"] = "Есть реагенты"
L["MEDIUM"] = "средне"
L["ONLY_SHOW"] = "Показывать только:"
L["OPTIMAL"] = "оптимально"
L["TRIVIAL"] = "банально"

elseif (locale == 'zhCN') then
--[[Translation missing --]]
--[[ L["ABOUT"] = " - by Angelike"--]] 
--[[Translation missing --]]
--[[ L["CRAFTABLE"] = "Craftable"--]] 
--[[Translation missing --]]
--[[ L["CRAFTHELPER"] = "Crafthelper"--]] 
--[[Translation missing --]]
--[[ L["DIFFICULT"] = "difficult"--]] 
--[[Translation missing --]]
--[[ L["EASY"] = "easy"--]] 
--[[Translation missing --]]
--[[ L["HAS_REAGENTS"] = "Has reagents"--]] 
--[[Translation missing --]]
--[[ L["MEDIUM"] = "medium"--]] 
--[[Translation missing --]]
--[[ L["ONLY_SHOW"] = "Only show:"--]] 
--[[Translation missing --]]
--[[ L["OPTIMAL"] = "optimal"--]] 
--[[Translation missing --]]
--[[ L["TRIVIAL"] = "trivial"--]] 

elseif (locale == 'zhTW') then
--[[Translation missing --]]
--[[ L["ABOUT"] = " - by Angelike"--]] 
--[[Translation missing --]]
--[[ L["CRAFTABLE"] = "Craftable"--]] 
--[[Translation missing --]]
--[[ L["CRAFTHELPER"] = "Crafthelper"--]] 
--[[Translation missing --]]
--[[ L["DIFFICULT"] = "difficult"--]] 
--[[Translation missing --]]
--[[ L["EASY"] = "easy"--]] 
--[[Translation missing --]]
--[[ L["HAS_REAGENTS"] = "Has reagents"--]] 
--[[Translation missing --]]
--[[ L["MEDIUM"] = "medium"--]] 
--[[Translation missing --]]
--[[ L["ONLY_SHOW"] = "Only show:"--]] 
--[[Translation missing --]]
--[[ L["OPTIMAL"] = "optimal"--]] 
--[[Translation missing --]]
--[[ L["TRIVIAL"] = "trivial"--]] 

end

local hookFns = {
	-- TradeSkill hooks
	'CollapseTradeSkillSubClass',
	'DoTradeSkill',
	'ExpandTradeSkillSubClass',
	'GetTradeSkillCooldown',
	'GetTradeSkillDescription', -- not in classic
	'GetTradeSkillIcon',
	'GetTradeSkillInfo',
	'GetTradeSkillItemLink',
	'GetTradeSkillItemStats', -- only in classic
	'GetTradeSkillNumMade',
	'GetTradeSkillNumReagents',
	'GetTradeSkillReagentInfo',
	'GetTradeSkillReagentItemLink',
	'GetTradeSkillRecipeLink', -- not in classic
	'GetTradeSkillTools',
	'SelectTradeSkill',
	'GetFirstTradeSkill',
	'GetNumTradeSkills',
	'GetTradeSkillSelectionIndex'
}

local frame;
local data = {
	['items'] = {}
};


addon:SetDefaultModuleState(false);
function addon:OnInitialize()
	-- init DB
	if (CrafthelperDB == nil) then
		CrafthelperDB = {};
	end
end

function addon:OnEnable()
	for _, fnName in ipairs(hookFns) do
		if (fnName:match(':')) then
			addon:createModuleHook(fnName);
		else
			addon:createGenericHook(fnName);
		end
	end

	addon:RegisterEvent('ADDON_LOADED');
end

function addon:OnDisable()
	-- will never happen, but keep it for completition
	addon:UnhookAll();
	addon:UnregisterAllEvents();
end

--
-- addon methodes
--
function addon:buildSkillList(name)
	local d = addon:getSkillData(name);
	d.items = newArray();

	d.headers.map(function(header)
		local displayItems = header.items.filter(function(item)
			return addon:isItemVisible(item, name);
		end);

		if (#displayItems == 0) then
			return;
		end

		if (header.dummy ~= true) then
			d.items.push(header);
		end

		displayItems = displayItems.filter(function(item)
			return item.index > 0;
		end)

		d.items.push(unpack(displayItems));
	end);
end

function addon:getHeader(skillIndex)
	local name, type = addon:callHook('GetItemInfo', skillIndex);
	local i = skillIndex;

	repeat
		i = i + 1;
		local id = addon:getItemId(i);

		if (id ~= nil and data.items[id] ~= nil) then
			return data.items[id].header;
		end
	until(id == nil)

	return {name = name, type = type};
end

function addon:getItemId(index)
	local link = addon:callHook('GetItemLink', index);

	if (link == nil) then
		return nil;
	end

	return addon.scanning.professionName .. '-' .. link:match(':(%d+)');
end

function addon:getRealIndex(index, name)
	local d = addon:getSkillData(name);
	local item = d.items[index];

	return item and item.index or 0;
end

function addon:getSkill(id, header)
	if (data.items[id] == nil) then
		data.items[id] = {
			header = header,
			id = id
		};
	end

	return data.items[id];
end

function addon:getSkillData(professionName)
	if (data[professionName] == nil) then 
		data[professionName] = {
			['headers'] = newArray();
			['items'] = newArray();
		};
	end

	return data[professionName];
end

function addon:hasReagents(index)
	for i = 0, addon:callHook('GetItemNumReagents', index) do
		local name, texture, needCount, hasCount = addon:callHook('GetItemReagentInfo', index, i);

		if (type(hasCount) == 'number' and hasCount >= needCount) then
			return true;
		end
	end

	return false
end

function addon:initDB(name)
	if (CrafthelperDB[name] == nil) then
		CrafthelperDB[name] = {
			craftable = false,
			difficulty = 1,
			hasReagents = false
		};
	end
end

function addon:initSkillSelect()
	local moduleName = self:GetParent():GetAttribute('module-name');
	local module = addon:GetModule(moduleName);
	local db = CrafthelperDB[module.professionName] or {};
	local colors = moduleName == 'CraftUI' and CraftTypeColor or TradeSkillTypeColor;

	for level, name in pairs(levels) do
		if (colors[name]) then
			local info = UIDropDownMenu_CreateInfo();

			local color = CreateColor(ColorMixin.GetRGBA(colors[name]));

			info.arg1 = moduleName;
			info.arg2 = 'difficulty';
			info.checked = level == db.difficulty;
			info.func = addon.selecktSkill;
			info.text = color:WrapTextInColorCode(L[string.upper(name)]);
			info.value = level;

			UIDropDownMenu_AddButton(info);
		end
	end
end

function addon:initFrames(parentFrame, module)
	module.frame = CreateFrame('Frame',nil, parentFrame, 'CrafthelperFrame');

	module.frame:SetAttribute('module-name', module:GetName());
	module.frame:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r ,TOOLTIP_DEFAULT_BACKGROUND_COLOR.g,TOOLTIP_DEFAULT_BACKGROUND_COLOR.b);

	module.frame.text:SetText(L['CRAFTHELPER']);
	module.frame.about:SetPoint('LEFT', module.frame.text:GetWidth() + 10, 0);
	module.frame.about:SetText(L['ABOUT']);
	module.frame.onlyShow:SetText(L['ONLY_SHOW']);

	module.frame.craftableButton.text:SetText(L['CRAFTABLE'])
	module.frame.craftableButton:SetScript('OnClick', addon.OnClickButton);

	module.frame.hasReagentsButton.text:SetText(L['HAS_REAGENTS'])
	module.frame.hasReagentsButton:SetScript('OnClick', addon.OnClickButton);

	UIDropDownMenu_Initialize(module.frame.skillDropDown, addon.initSkillSelect);
end

function addon:isItemVisible(item, professionName)
	local settings = CrafthelperDB[professionName];

	if (item.level < settings.difficulty) then
		return false
	end

	if (settings.craftable and item.craftable == false) then
		return false
	end

	if (settings.hasReagents and item.hasReagents == false) then
		return false;
	end

	return true;
end

function addon:scan()
	local header, i, id, skill;
	local d = addon:getSkillData(addon.scanning.professionName);

	d.headers = newArray();

	local header = {dummy = true, items = newArray(), level = 0};
	d.headers.push(header)

	for i = 1, addon:callHook('GetNumItems'), 1 do
		local name, type, numCraftable, isExpanded = addon:callHook('GetItemInfo', i);

		if (type == 'header') then
			header = addon:getHeader(i);

			d.headers.push(header);

			header.index = i;
			header.items = newArray();
			header.level = 0;

			if (isExpanded == nil) then
				addon:scanCollapsedHeader(header);
			end
		elseif (i <= addon:callHook('GetNumItems')) then
			id = addon:getItemId(i);
			skill = addon:getSkill(id, header);

			skill.name = name;
			skill.index = i;
			skill.level = levels.indexOf(type);
			skill.craftable = numCraftable > 0;
			skill.hasReagents = addon:hasReagents(i);

			header.items.push(skill)
			header.level = math.max(header.level, skill.level);
		end
	end

	addon:buildSkillList(addon.scanning.professionName);
end

function addon:scanCollapsedHeader(header)
	local numSkills = addon:callHook('GetNumItems')
	addon:callHook('ExpandItemHeader', header.index);
	local numSkillsTmp = addon:callHook('GetNumItems');

	for i = header.index + 1, numSkillsTmp - numSkills + header.index do
  		local name, type, numCraftable = addon:callHook('GetItemInfo', i);
		id = addon:getItemId(i);

		skill = addon:getSkill(id, header);
		skill.name = name;
		skill.index = 0;
		skill.level = levels.indexOf(type);
		skill.craftable = numCraftable > 0;
		skill.hasReagents = addon:hasReagents(i);

		header.items.push(skill)
		header.level = math.max(header.level, skill.level);
	end

	addon:callHook('CollapseItemHeader', header.index);
end

function addon.selecktSkill(self, arg1, arg2)
	local module = addon:GetModule(arg1);

	UIDropDownMenu_SetSelectedValue(module.frame.skillDropDown, self.value);

	CrafthelperDB[module.professionName][arg2] = self.value;
	addon:buildSkillList(module.professionName);
	module:updateFrame();
end

function addon:updateButtons()
	local options = CrafthelperDB[addon.scanning.professionName];
	local difficultly = levels[options.difficulty];
	local colors = CraftTypeColor or TradeSkillTypeColor;
	local color = CreateColor(ColorMixin.GetRGBA(colors[difficultly]));

	addon.scanning.frame.craftableButton:SetChecked(options.craftable);
	addon.scanning.frame.hasReagentsButton:SetChecked(options.hasReagents);
	UIDropDownMenu_SetSelectedValue(addon.scanning.frame.skillDropDown, options.difficulty);
	UIDropDownMenu_SetText(addon.scanning.frame.skillDropDown, color:WrapTextInColorCode(L[string.upper(difficultly)]));
end

--
-- Events
--

function addon:ADDON_LOADED(_, eventName)
	if (eventName == 'Blizzard_TradeSkillUI') then
		addon:GetModule('TradeSkillUI'):Enable();
	elseif (eventName == 'Blizzard_CraftUI') then
		addon:GetModule('CraftUI'):Enable();
	end
end

function addon:OnClickButton(checked)
	local frame = self:GetParent();
	local moduleName = frame:GetAttribute('module-name');
	local module = addon:GetModule(moduleName);

	CrafthelperDB[module.professionName].craftable = frame.craftableButton:GetChecked();
	CrafthelperDB[module.professionName].hasReagents = frame.hasReagentsButton:GetChecked();

	addon:buildSkillList(module.professionName);
	module:updateFrame()
end

--
-- Hooks
--

function addon:callHook(name, ...)
	local fnName = addon.scanning[name];

	if (fnName == nil) then
		error(name .. ' not found!');
	end

    local fn = addon:IsHooked(fnName) and addon.hooks[fnName] or _G[fnName];

	if(fnName == 'GetCraftInfo') then
		local data = {fn(...)};
		table.remove(data, 2, 1)

		return unpack(data);
	end

	return fn(...);
end

function addon:createGenericHook(fnName)
	if (_G[fnName] == nil) then
		return;
	end

	local moduleName = fnName:match('Trade') ~= nil and 'TradeSkillUI' or 'CraftUI';
	local module = addon:GetModule(moduleName);

	module[fnName] = module[fnName] or function(index, ...)
		local realIndex = addon:getRealIndex(index, module.professionName);

		return addon.hooks[fnName](realIndex, ...);
	end

	addon:RawHook(fnName, module[fnName], true);
end
